require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_IOPRIO_H)) {
    eval 'sub _LINUX_IOPRIO_H () {1;}' unless defined(&_LINUX_IOPRIO_H);
    require 'linux/stddef.ph';
    require 'linux/types.ph';
    eval 'sub IOPRIO_CLASS_SHIFT () {13;}' unless defined(&IOPRIO_CLASS_SHIFT);
    eval 'sub IOPRIO_NR_CLASSES () {8;}' unless defined(&IOPRIO_NR_CLASSES);
    eval 'sub IOPRIO_CLASS_MASK () {( &IOPRIO_NR_CLASSES - 1);}' unless defined(&IOPRIO_CLASS_MASK);
    eval 'sub IOPRIO_PRIO_MASK () {((1 <<  &IOPRIO_CLASS_SHIFT) - 1);}' unless defined(&IOPRIO_PRIO_MASK);
    eval 'sub IOPRIO_PRIO_CLASS {
        my($ioprio) = @_;
	    eval q(((($ioprio) >>  &IOPRIO_CLASS_SHIFT) &  &IOPRIO_CLASS_MASK));
    }' unless defined(&IOPRIO_PRIO_CLASS);
    eval 'sub IOPRIO_PRIO_DATA {
        my($ioprio) = @_;
	    eval q((($ioprio) &  &IOPRIO_PRIO_MASK));
    }' unless defined(&IOPRIO_PRIO_DATA);
    eval("sub IOPRIO_CLASS_NONE () { 0; }") unless defined(&IOPRIO_CLASS_NONE);
    eval("sub IOPRIO_CLASS_RT () { 1; }") unless defined(&IOPRIO_CLASS_RT);
    eval("sub IOPRIO_CLASS_BE () { 2; }") unless defined(&IOPRIO_CLASS_BE);
    eval("sub IOPRIO_CLASS_IDLE () { 3; }") unless defined(&IOPRIO_CLASS_IDLE);
    eval("sub IOPRIO_CLASS_INVALID () { 7; }") unless defined(&IOPRIO_CLASS_INVALID);
    eval 'sub IOPRIO_LEVEL_NR_BITS () {3;}' unless defined(&IOPRIO_LEVEL_NR_BITS);
    eval 'sub IOPRIO_NR_LEVELS () {(1<<  &IOPRIO_LEVEL_NR_BITS);}' unless defined(&IOPRIO_NR_LEVELS);
    eval 'sub IOPRIO_LEVEL_MASK () {( &IOPRIO_NR_LEVELS - 1);}' unless defined(&IOPRIO_LEVEL_MASK);
    eval 'sub IOPRIO_PRIO_LEVEL {
        my($ioprio) = @_;
	    eval q((($ioprio) &  &IOPRIO_LEVEL_MASK));
    }' unless defined(&IOPRIO_PRIO_LEVEL);
    eval 'sub IOPRIO_BE_NR () { &IOPRIO_NR_LEVELS;}' unless defined(&IOPRIO_BE_NR);
    eval("sub IOPRIO_WHO_PROCESS () { 1; }") unless defined(&IOPRIO_WHO_PROCESS);
    eval("sub IOPRIO_WHO_PGRP () { 2; }") unless defined(&IOPRIO_WHO_PGRP);
    eval("sub IOPRIO_WHO_USER () { 3; }") unless defined(&IOPRIO_WHO_USER);
    eval 'sub IOPRIO_NORM () {4;}' unless defined(&IOPRIO_NORM);
    eval 'sub IOPRIO_BE_NORM () { &IOPRIO_NORM;}' unless defined(&IOPRIO_BE_NORM);
    eval 'sub IOPRIO_HINT_SHIFT () { &IOPRIO_LEVEL_NR_BITS;}' unless defined(&IOPRIO_HINT_SHIFT);
    eval 'sub IOPRIO_HINT_NR_BITS () {10;}' unless defined(&IOPRIO_HINT_NR_BITS);
    eval 'sub IOPRIO_NR_HINTS () {(1<<  &IOPRIO_HINT_NR_BITS);}' unless defined(&IOPRIO_NR_HINTS);
    eval 'sub IOPRIO_HINT_MASK () {( &IOPRIO_NR_HINTS - 1);}' unless defined(&IOPRIO_HINT_MASK);
    eval 'sub IOPRIO_PRIO_HINT {
        my($ioprio) = @_;
	    eval q(((($ioprio) >>  &IOPRIO_HINT_SHIFT) &  &IOPRIO_HINT_MASK));
    }' unless defined(&IOPRIO_PRIO_HINT);
    eval("sub IOPRIO_HINT_NONE () { 0; }") unless defined(&IOPRIO_HINT_NONE);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_1 () { 1; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_1);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_2 () { 2; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_2);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_3 () { 3; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_3);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_4 () { 4; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_4);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_5 () { 5; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_5);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_6 () { 6; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_6);
    eval("sub IOPRIO_HINT_DEV_DURATION_LIMIT_7 () { 7; }") unless defined(&IOPRIO_HINT_DEV_DURATION_LIMIT_7);
    eval 'sub IOPRIO_BAD_VALUE {
        my($val, $max) = @_;
	    eval q((($val) < 0|| ($val) >= ($max)));
    }' unless defined(&IOPRIO_BAD_VALUE);
    eval 'sub IOPRIO_PRIO_VALUE {
        my($prioclass, $priolevel) = @_;
	    eval q( &ioprio_value($prioclass, $priolevel,  &IOPRIO_HINT_NONE));
    }' unless defined(&IOPRIO_PRIO_VALUE);
    eval 'sub IOPRIO_PRIO_VALUE_HINT {
        my($prioclass, $priolevel, $priohint) = @_;
	    eval q( &ioprio_value($prioclass, $priolevel, $priohint));
    }' unless defined(&IOPRIO_PRIO_VALUE_HINT);
}
1;
